<template>
    <v-card class="w-[350px]">
        <LanguageSwitch />
        <Logo />

        <div class="flex justify-center mb-8">
            <h1 v-if="isResetPassword" class="text-secondary text-xl leading-8 mb-2">
                {{ translate('reset_password.title') }}
            </h1>
            <h1 v-else class="text-secondary text-xl leading-8 mb-2">
                {{ translate('activate_account.title') }}
            </h1>
        </div>

        <div class="my-3">
            <v-form ref="form" @submit.prevent="resetPassword()">
                <v-text-field
                    v-model="data.password"
                    id="password"
                    persistent-placeholder
                    :label="translate('labels.password')"
                    validate-on="submit"
                    :rules="validator.setRules('required|min:5').validate()"
                    :append-inner-icon="show ? 'mdi-eye-outline' : 'mdi-eye-off-outline'"
                    :type="show ? 'text' : 'password'"
                    @click:append-inner="show = !show"
                    maxlength="30"
                ></v-text-field>

                <v-text-field
                    v-model="data.password_confirmation"
                    id="confirmation"
                    class="my-3"
                    :label="translate('validation.password_confirm')"
                    :rules="passwordConfirmRule"
                    persistent-placeholder
                    :append-inner-icon="showConfirm ? 'mdi-eye-outline' : 'mdi-eye-off-outline'"
                    validate-on="submit"
                    @click:append-inner="showConfirm = !showConfirm"
                    :type="showConfirm ? 'text' : 'password'"
                    maxlength="30"
                ></v-text-field>

                <v-btn type="submit" color="secondary" block>
                    {{ translate('labels.submit') }}
                </v-btn>
            </v-form>
        </div>
    </v-card>
</template>

<script lang="ts" setup>
import { ref, inject, onBeforeMount, onMounted } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { useI18n } from 'vue-i18n';
import { Api } from '@/enums/apiEnum';
import { StoreFactory } from '@/stores';
import { storeFactory } from '@/main';

// Components
import Logo from '@/components/LogoImage.vue';
import LanguageSwitch from '@/components/language/LanguageSwitch.vue';

//Validator
import { Validator } from '@/helpers/Validator';

const auth = inject(Api.Auth) as any;
const isResetPassword = ref(true);

const pdToast = storeFactory.toastStore;
const configStore = StoreFactory.configStore;
const route = useRoute();
const router = useRouter();
const { t: translate } = useI18n();

const token = ref('');
const email = ref('');
const language = ref('');
const userId = ref(0 as number);
const form = ref(null) as any;
const validator = new Validator();
const show = ref(false);
const showConfirm = ref(false);
const passwordConfirmRule = ref([]) as any;

const data = ref({
    email: '',
    password: '',
    password_confirmation: '',
});

passwordConfirmRule.value.push(
    (value: string) => value == data.value.password || translate('validation.passwords_mismatch')
);

onBeforeMount(() => {
    if (route.query.l) {
        language.value = route.query.l as string;
        configStore.setLocale(language.value);
    }
});

onMounted(() => {
    if (route.path.includes('activate')) {
        isResetPassword.value = false;
    }
    if (route.query.email && route.params.token && route.query.l) {
        token.value = route.params.token as string;
        email.value = route.query.email as string;
        language.value = route.query.l as string;
        data.value.email = email.value;

        userId.value = route.query.id;

        configStore.setLocale(language.value);
    } else {
        pdToast.danger(translate('labels.error'), translate('notifications.contact_admin'), { timeout: 25000 });
    }
});

const resetPassword = async () => {
    if (!(await form.value.validate())?.valid) {
        return;
    }

    auth.userEndpoint
        .resetPasswordUpdate(data.value.email, data.value.password, data.value.password_confirmation, token.value)
        .then(() => {
            pdToast.success(translate('labels.new') + ' ' + translate('labels.password'), '', {
                timeout: 15000,
            });

            router.push({
                name: 'authentication.login',
            });
        })
        .catch((error: any) => {
            if (Object.keys(error.response.data).length == 0) {
                pdToast.danger(translate('labels.error'), error.message, { timeout: 25000 });
            } else {
                error.response.data.errors.forEach((error: { detail: any }) => {
                    pdToast.danger(translate('labels.error'), error.detail, { timeout: 25000 });
                });
            }
        });
};
</script>
